from smartdiffusion.config import MAX_RESOLUTION


class GLIGENTextBoxApply:
    @classmethod
    def INPUT_TYPES(s):
        return {
            "required": {
                "conditioning_to": ("CONDITIONING",),
                "clip": ("CLIP",),
                "gligen_textbox_model": ("GLIGEN",),
                "text": ("STRING", {"multiline": True, "dynamicPrompts": True}),
                "width": (
                    "INT",
                    {"default": 64, "min": 8, "max": MAX_RESOLUTION, "step": 8},
                ),
                "height": (
                    "INT",
                    {"default": 64, "min": 8, "max": MAX_RESOLUTION, "step": 8},
                ),
                "x": (
                    "INT",
                    {"default": 0, "min": 0, "max": MAX_RESOLUTION, "step": 8},
                ),
                "y": (
                    "INT",
                    {"default": 0, "min": 0, "max": MAX_RESOLUTION, "step": 8},
                ),
            }
        }

    RETURN_TYPES = ("CONDITIONING",)
    FUNCTION = "append"

    CATEGORY = "conditioning/gligen"

    def append(
        self, conditioning_to, clip, gligen_textbox_model, text, width, height, x, y
    ):
        c = []
        cond, cond_pooled = clip.encode_from_tokens(
            clip.tokenize(text), return_pooled="unprojected"
        )
        for t in conditioning_to:
            n = [t[0], t[1].copy()]
            position_params = [(cond_pooled, height // 8, width // 8, y // 8, x // 8)]
            prev = []
            if "gligen" in n[1]:
                prev = n[1]["gligen"][2]
            n[1]["gligen"] = ("position", gligen_textbox_model, prev + position_params)
            c.append(n)
        return (c,)
